#include "StdAfx.h"
#include "ProcessClear.h"


const TCHAR NTALKUPDATER_GUID[] = _T("678F4EA5-8292-4dff-8202-D5F8EEAD66E2");
const TCHAR NSIS_GUID[] = _T("497B2C88-8CC9-4552-9914-CA161327C903");

CProcessClear::CProcessClear(void) : m_receiveCallback(this)
{
}

CProcessClear::~CProcessClear(void)
{
}

BOOL CProcessClear::Clear()
{
	
	BOOL bSuccess = FALSE;
	HANDLE nsisMutex = NULL;
	if (FALSE == m_batUtil.CreateMutex(NSIS_GUID, nsisMutex))
		return bSuccess;

	if(m_batUtil.IsRunProgram(NTALKUPDATER_GUID) == TRUE)
	{
		m_bProgramQuit = FALSE;
		m_bIPCConnect = FALSE;
		tipbase::IPCStringKey host(_T("NtalkbizBat"));
		m_server.Create(&host);
		tipbase::IPCStringKey key( _T("NtalkbizUpgrader"));
		tipbase::IIPCHandle* handle = m_server.Find(&key, &m_receiveCallback);
		TCHAR connectData[] = _T("request_connect");
		handle->Write((const BYTE*)connectData, (_tcslen(connectData)+1)*sizeof(TCHAR));

		Sleep(500); //  ٸ
		if (m_bIPCConnect == FALSE)
		{
			if (nsisMutex)
			{
				m_batUtil.DeleteMutex(nsisMutex);
			}
			return bSuccess;
		}

		TCHAR quitCommandData[] = _T("quit_command");
		handle->Write((const BYTE*)quitCommandData, (_tcslen(quitCommandData)+1)*sizeof(TCHAR));
		while(m_bProgramQuit == FALSE)
		{
			Sleep(1000);			
			handle->Write((const BYTE*)quitCommandData, (_tcslen(quitCommandData)+1)*sizeof(TCHAR));
		}
	}

	if (nsisMutex)
		m_batUtil.DeleteMutex(nsisMutex);

	return bSuccess;
}
